; 

    .486                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\macros\macros.asm

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

    .data?
      swid dd ?
      shgt dd ?
      hDC  dd ?
      cDC  dd ?
      hScr dd ?
      hBmp dd ?
      hOld dd ?

    .code

; 

start:

main proc

    mov hScr, 0                                         ; screen handle is zero
    mov hDC,  rv(GetDC,hScr)                            ; get its DC
    mov swid, rv(GetSystemMetrics,SM_CXSCREEN)          ; get screen width
    mov shgt, rv(GetSystemMetrics,SM_CYSCREEN)          ; get the screen height
    mov hBmp, rv(CreateCompatibleBitmap,hDC,swid,shgt)  ; make double width bitmap
    mov cDC,  rv(CreateCompatibleDC,hDC)                ; create a DC for it
    mov hOld, rv(SelectObject,cDC,hBmp)                 ; select compatible bitmap into compatible DC

  ; ------------------------------------------------
  ; blit a copy of the current screen
  ; ------------------------------------------------
    invoke BitBlt,cDC,0,0,swid,shgt,hDC,0,0,SRCCOPY

  ; --------------------------------------------------------
  ; blit the screen from left to right
  ; --------------------------------------------------------
    push esi
    push edi
    mov esi, 0
    mov edi, swid

  @@:
    sub edi, 1
    js @F
    invoke BitBlt,hDC,edi,0,1,shgt,cDC,esi,0,SRCCOPY
;   invoke Sleep, 10                             ; slow it up a bit
    add esi, 1
    jmp @B

  @@:

    invoke DeleteObject,hBmp                            ; delete the compatible bitmap
    invoke SelectObject,cDC,hOld                        ; reselect the old one
    invoke DeleteDC,cDC                                 ; delete the compatible DC
    invoke ReleaseDC,hScr,hDC                           ; release the screen DC

    invoke Sleep, 2000

    pop edi
    pop esi

    invoke InvalidateRect, 0, 0, FALSE
    invoke UpdateWindow, 0

    exit

main endp

; 

end start
